#include <gtk/gtk.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <gtkgl/gtkglarea.h>
#include <libgimp/gimp.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>

typedef enum 
{
  IMAGE_POINT,
  FOREGROUND_POINT,
  GRADIENT_POINT,

  FOREGROUND_LINE,
  GRADIENT_LINE,
  IMAGE_LINE,
  IMAGE_FILL,
  GRADIENT_FILL
} _display_mode;

typedef enum 
{
  VRML1,
  BLENDER
} _export_mode; 

typedef enum 
{
  VALUE,
  ALPHA,
  RED,
  GREEN,
  BLUE
} _displacement_mode;

typedef struct 
{
  /* determine the mesh */
  _display_mode display_mode;
  _export_mode export_mode;
  _displacement_mode displacement_mode;

  /* mesh display stuff */
  gfloat displacement_scale; 
  guint rowspan;
  guint colspan;
  gint row_sample_rate;
  gint col_sample_rate;

  /* view interaction stuff that should me moved to another struct */
  float x,y;   /* eye position for panning */
  float zoom;  
  float quat[4]; /* the ubitquitus quaternion rotation */
  gboolean update_set;
  gint update_interval;
  gint update_count;
  gint update_tag;

  guchar *gradient;
  guchar *field;
} hft_mesh;

