#include "hft_export.h"

void hft_export(GtkWidget *w, GtkFileSelection *fs)
{
  FILE *export_file;
  gchar *file_name;

  file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  export_file = fopen (file_name, "w");
  if (export_file == NULL) 
    {
      g_print("cant write %s\n",file_name);
      return;
    }

  switch(hft_current.export_mode)
    {
    case VRML1: hft_export_vrml(export_file); break;
    default: hft_export_blender(export_file); break;
    }

  fclose(export_file);
}

void hft_export_vrml(FILE *export_file)
{
  gint row, col;

  /*----------------------------------------*/
  fputs("#VRML V1.0 ascii

Separator {   
   Coordinate3 {
            point [
", export_file);
  /*---------------------------------------*/
          
  for (row = 0;row < hft_current.rowspan; row++)  
    {
      for (col = 0;col < hft_current.colspan; col++) 
	{
	  fprintf(export_file,"%f %f %f ,",
		  (float) col * hft_current.col_sample_rate
		  - (GLfloat)(hft_drawable->width * 0.5),

		  hft_current.field [(hft_current.colspan * row)+ col]
		  * hft_drawable->width/256 * hft_current.displacement_scale
		  - (GLfloat)(hft_drawable->width * 0.5) 
		   * hft_current.displacement_scale,

		  (float) row * hft_current.row_sample_rate
		  - (GLfloat)(hft_drawable->height * 0.5) 
		  );
	}
    }

  /*--------------------------------------*/
  fputs("
                  ]
   }

   IndexedFaceSet {
         coordIndex [
",export_file);
  /*--------------------------------------*/

 for (row = 0;row < (hft_current.rowspan-1); row++)  
    {
      for (col = 0;col < (hft_current.colspan-1); col++) 
	{
	  fprintf(export_file,"%d, %d, %d, -1,",
		  row * hft_current.colspan + col, 
		  row * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col);
	  fprintf(export_file,"%d, %d, %d, -1,",
		  row * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col );
	}
    }

 /*--------------------------------------*/
  fputs("
                    ]
    }
}
",export_file);
  /*-------------------------------------*/
}

void hft_export_blender(FILE *export_file) // just do inventor?
{
  gint row, col;

  fputs("GOUR\n",export_file);
  fprintf(export_file,"%d\n",
	  hft_current.colspan * hft_current.rowspan);

  for (row = 0;row < hft_current.rowspan; row++)  
    {
      for (col = 0;col < hft_current.colspan; col++) 
	{
	  fprintf(export_file,"%f %f %f 0x%X%X%X\n",
		  (float) col * hft_current.col_sample_rate
		  - (GLfloat)(hft_drawable->width * 0.5),

		  hft_current.field [(hft_current.colspan * row)+ col]
		  * hft_drawable->width/256 * hft_current.displacement_scale
		  - (GLfloat)(hft_drawable->width * 0.5) 
		   * hft_current.displacement_scale,

		  (float) row * hft_current.row_sample_rate
		  - (GLfloat)(hft_drawable->height * 0.5),
 
		  (int) hft_current.gradient
		  [(hft_current.colspan * row)*4 + col],
		  (int) hft_current.gradient
		  [(hft_current.colspan * row)*4 + col + 1],
		  (int) hft_current.gradient
		  [(hft_current.colspan * row)*4 + col + 2] 
		  );
	}
    }

  for (row = 0;row < hft_current.rowspan; row++)  
    {
      for (col = 0;col < hft_current.colspan; col++) 
	{
	  fprintf(export_file,"3 %d %d %d\n",
		  row * hft_current.colspan + col, 
		  row * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col
		  );
	  fprintf(export_file,"3 %d %d %d\n",
		  row * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col + 1, 
		  (row + 1) * hft_current.colspan + col
		  );
	}
    } 
}


