#include "hft.h"

/*----from main-----*/
extern GDrawable *hft_drawable;
extern hft_mesh hft_current;

/*---from view----*/
extern GtkWidget *hft_glarea;
extern void hft_draw();
extern void hft_make_field();
extern void hft_get_gradient();

/*---from export---*/
void hft_export(GtkFileSelection *fs);

/*---local-----*/
void hft_interface();
static void make_display_mode_menu(GtkWidget *box);
static void make_displacement_mode_menu(GtkWidget *box);
static void hft_export_dialog();

void set_auto_update(gboolean this_request);
void auto_update_callback(GtkWidget *widget, gpointer data);
static void update_callback();
static void update_delay_callback(GtkAdjustment *adjustment, gint *val);

static void display_mode_foreground_point_callback();
static void display_mode_gradient_point_callback();
static void display_mode_image_point_callback();
static void display_mode_image_line_callback();
static void display_mode_foreground_line_callback();
static void display_mode_gradient_line_callback();
static void display_mode_image_fill_callback();
static void display_mode_gradient_fill_callback();

static void displacement_mode_value_callback();
static void displacement_mode_alpha_callback();
static void displacement_mode_red_callback();
static void displacement_mode_green_callback();
static void displacement_mode_blue_callback();

static void scale_callback(GtkAdjustment *adjustment, gfloat *val);
static void row_sample_callback(GtkAdjustment *adjustment, gfloat *val);
static void col_sample_callback(GtkAdjustment *adjustment, gfloat *val);

