#include "hft_main.h"

MAIN()

static void query()
{
  const char *name_of_plug_in =        "height field toy";
  const char *author =                 "pixel fairy <pixel@slimey.com>";
  const char *copyrights =             "pixel fairy <pixel@slimey.com>";
  const char *copyright_date =         "1999";
  const char *menu_path =              "<Image>/X/height field toy";
  const char *color_modes_accepted =   "GRAY*,RGB*";
  const int number_of_arguments =      3;
  const int number_of_return_values =  0;
  
  const char *what_it_does =                  
    "View/play with this drawable as a height field. stick it in blender!";
 
  const char *help_string = "Help?!? Im the one that needs help!";
 
  static GParamDef args[] = 
  {
    { PARAM_INT32, "run_mode", "Interactive, non-interactive" },
    { PARAM_IMAGE, "image", "Input image (unused)" },
    { PARAM_DRAWABLE, "drawable", "Input drawable" },
  };    
  
  static GParamDef *return_vals = NULL;
  
  gimp_install_procedure
    (
     (char *) name_of_plug_in,   
     (char *) what_it_does,
     (char *) help_string,
     (char *) author,
     (char *) copyrights,
     (char *) copyright_date,
     (char *) menu_path,
     (char *) color_modes_accepted,
     PROC_PLUG_IN,
     number_of_arguments, 
     number_of_return_values,
     args, 
     return_vals
     );
}

static void run(char *name, int nparams, GParam *param, 
		int *nreturn_vals,GParam **return_vals)
{
  GStatusType status = STATUS_SUCCESS;
  GRunModeType run_mode;
  static GParam values[1];
  values[0].type = PARAM_STATUS;
  values[0].data.d_status = status;
  *nreturn_vals = 1;
  *return_vals = values;

  /* get the drawable */
  hft_drawable = gimp_drawable_get(param[2].data.d_drawable);

  run_mode = param[0].data.d_int32;

  switch(run_mode)
    {
    case RUN_INTERACTIVE:
    case RUN_WITH_LAST_VALS: 
      hft_run_interactive();
      break;
    case RUN_NONINTERACTIVE:
      if (nparams != 3) 
	{
	  status = STATUS_CALLING_ERROR;
	  break;
	}
      g_print ("non interactive not implemented yet");
      break;
    default: break;
    }

  values[0].data.d_status = status;
  gimp_drawable_detach(hft_drawable);
}

void hft_run_interactive()
{
  char **argv;
  int argc;
  argc = 1;
  argv = g_new(gchar*, sizeof("hft"));  
  argv[0] = g_strdup("hft");  
  
  gtk_init(&argc, &argv);
  gtk_rc_parse(gimp_gtkrc ());

  hft_view(); 
  hft_interface();

  gtk_main(); 
}

