#include "hft.h"

/*----exported----*/
GDrawable *hft_drawable;

hft_mesh hft_current = 
{
  IMAGE_POINT,           /* color of displayed geometry */
  VRML1,         /* export file type */
  VALUE,           /* displacement style for color images */

  1,               /* displacement scale factor */
  0,               /* number of rows */
  0,               /* number of colums */
  0,               /* row sample rate */
  0,               /* colum sample rate */ 

  0,               /* current X */
  0,               /* current Y */
  40,              /* zoom */
  {0, 0, 0, 1},    /* rotation quaternion */
  FALSE,           /* flag for auto update */
  UPDATE_INTERVAL, /* how often the mesh is reread for auto update */
  0,               /* count of events preventing auto update */
  0,               /* tag for the time out func */

  NULL,            /* active gradient */ 
  NULL             /* array of unsigned ints representing the field */
};

/*----external----*/
extern void hft_view();
extern void hft_interface();

/*----local---*/

static void query();
static void run(
    char *name,
    int nparams,
    GParam *param,
    int *nreturn_vals,
    GParam **return_vals
);

GPlugInInfo PLUG_IN_INFO = {
    NULL,    /* init_proc */
    NULL,    /* quit_proc */
    query,   /* query_proc */
    run,     /* run_proc */
};

void hft_run_interactive();

















