#include "hft.h"
#include "trackball.h"

/*defined in main*/
extern GDrawable *hft_drawable;
extern hft_mesh hft_current;

/*defined in interface*/
extern void set_auto_update(gboolean);

/*local constants*/

#ifndef MESH_DENSITY
#define MESH_DENSITY 100
#endif

#ifndef GRAY_THRESHOLD
#define GRAY_THRESHOLD 25
#endif

const int X = 0;
const int Y = 1;
const int Z = 2;

/*local variables*/
GtkWidget *hft_glarea;
GLfloat eye[3]; 
gint quadrant;

/*local functions*/
void hft_view();
static void hft_view_init();
static void hft_gl_init();

void hft_make_field();
inline void hft_make_field_value(guchar* pixel_buffer);
inline void hft_make_field_alpha(guchar* pixel_buffer);
inline void hft_make_field_rgb(guchar* pixel_buffer);

void hft_get_gradient();

void hft_draw();
void hft_draw_foreground_point();
void hft_draw_image_point();
void hft_draw_gradient_point();
void hft_draw_image_line();
void hft_draw_foreground_line();
void hft_draw_gradient_line();
void hft_draw_image_fill();
void hft_draw_gradient_fill();

inline void gradient_point(int row, int col);
inline void place_vertex(int row, int col);

void motion_notify(GtkWidget *widget, GdkEventMotion *event);
static void button_press();
static void button_release();
 
static gint expose_callback(GtkWidget *widget, GdkEventExpose *event);
static gint reshape(GtkWidget *widget, GdkEventConfigure *event);


 
 
